package net.cattaka.rdbassistant.gui.script;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTable;
import net.cattaka.rdbassistant.RdbaMessageConstants;
import net.cattaka.rdbassistant.bean.RdbaSingletonBundle;
import net.cattaka.rdbassistant.config.RdbaConfig;
import net.cattaka.rdbassistant.gui.RdbaGuiInterface;
import net.cattaka.rdbassistant.gui.RdbaMessage;
import net.cattaka.rdbassistant.gui.table.ResultSetTablePanel;
import net.cattaka.rdbassistant.gui.table.ResultSetTableModel;
import net.cattaka.swing.util.ButtonsBundle;

public class ResultTablePanel extends JPanel implements RdbaGuiInterface {
	private static final long serialVersionUID = 1L;
	private ResultSetTablePanel resultSetTable;
	private RdbaGuiInterface parentComponent;
	
	class ButtonAction implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getActionCommand().equals("transpose")) {
				transpose();
			}
		}
	}

	public ResultTablePanel(RdbaGuiInterface parentComponent) {
		this.parentComponent = parentComponent;
		makeLayout();
	}
	
	private void makeLayout() {
		ButtonAction buttonAction = new ButtonAction();
		
		JButton transposeButton;
		{
			// ボタン作成
			Icon iconTranspose = (Icon)getRdbaSingletonBundle().getResource(RdbaMessageConstants.ICON_TRANSPOSE);
			transposeButton = new JButton();
			transposeButton.setActionCommand("transpose");
			transposeButton.addActionListener(buttonAction);
			ButtonsBundle.applyButtonDifinition(transposeButton, iconTranspose, "transpose", true);
		}
		resultSetTable = new ResultSetTablePanel();
		{
			resultSetTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			resultSetTable.setCellSelectionEnabled(true);
		}
		
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 0;
		gbc.weighty = 0;
		gbl.setConstraints(transposeButton, gbc);
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx++;
		gbc.gridheight = 2;
		gbc.weightx = 1;
		gbc.weighty = 1;
		gbl.setConstraints(resultSetTable, gbc);
		
		this.setLayout(gbl);
		this.add(transposeButton);
		this.add(resultSetTable);
	}
	private void transpose() {
		this.resultSetTable.setTransposed(!this.resultSetTable.isTransposed());
	}

	public void setResultSetTableModel(ResultSetTableModel dataModel) {
		resultSetTable.setResultSetTableModel(dataModel);
	}

	public void doGuiLayout() {
		// 無し
	}
	public RdbaConfig getRdbaConfig() {
		return parentComponent.getRdbaConfig();
	}
	public RdbaSingletonBundle getRdbaSingletonBundle() {
		return parentComponent.getRdbaSingletonBundle();
	}
	public void relayRdbaMessage(RdbaMessage rdbaMessage) {
		// 無し
	}
	public void reloadRdbaConfig() {
		RdbaConfig rdbaConfig = getRdbaConfig();
		this.resultSetTable.setFont(rdbaConfig.getFontForTable());
	}
	public void sendRdbaMessage(RdbaMessage rdbaMessage) {
		parentComponent.sendRdbaMessage(rdbaMessage);
	}
	
}
