package net.cattaka.rdbassistant.gui.table;

import javax.swing.event.TableModelListener;

import net.cattaka.rdbassistant.RdbaConstants;

public class TransposedTableModel implements ResultSetTableModel {
	private ResultSetTableModel tableModel;
	private int[] columnCharacters;
	private int columnWidth;
	
	public TransposedTableModel(ResultSetTableModel tableModel) {
		this.tableModel = tableModel;
		// 列幅の計算
		int[] origColumnCharacters = this.tableModel.getColumnCharacters();
		this.columnWidth = RdbaConstants.MINIMUM_COLUMN_CHARACTERS;
		for (int i=0;i<origColumnCharacters.length;i++) {
			if (this.columnWidth < origColumnCharacters[i]) {
				this.columnWidth = origColumnCharacters[i];
			}
		}
		
		// 列幅の設定
		this.columnCharacters = new int[tableModel.getRowCount()];
		for (int i=0;i<this.columnCharacters.length;i++) {
			this.columnCharacters[i] = columnWidth;
		}
	}

	public ResultSetTableModel getTableModel() {
		return tableModel;
	}

	public void setTableModel(ResultSetTableModel tableModel) {
		this.tableModel = tableModel;
	}

	public void addTableModelListener(TableModelListener l) {
		tableModel.addTableModelListener(l);
	}

	public Class<?> getColumnClass(int columnIndex) {
		//return tableModel.getColumnClass(columnIndex);
		return String.class;
	}

	public int getColumnCount() {
		//return tableModel.getColumnCount();
		return tableModel.getRowCount();
	}

	public String getColumnName(int columnIndex) {
		return tableModel.getRowName(columnIndex).toString();
	}

	public Object getRowName(int row) {
		return tableModel.getColumnName(row);
	}

	public int getRowCount() {
		//return tableModel.getRowCount();
		return tableModel.getColumnCount();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		return tableModel.getValueAt(columnIndex, rowIndex);
	}

	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return tableModel.isCellEditable(columnIndex, rowIndex);
	}

	public void removeTableModelListener(TableModelListener l) {
		tableModel.removeTableModelListener(l);
	}

	public void setValueAt(Object value, int rowIndex, int columnIndex) {
		tableModel.setValueAt(value, columnIndex, rowIndex);
	}

	public int[] getColumnCharacters() {
		//return tableModel.getColumnCharacters();
		return this.columnCharacters;
	}

	public String getTableName() {
		return tableModel.getTableName();
	}

	public Class<?> getRowHeaderClass() {
		return String.class;
	}
}
