package net.cattaka.rdbassistant.jspf.core;

import java.io.PrintWriter;
import java.sql.SQLException;

import net.cattaka.rdbassistant.jspf.core.bean.DatabaseInfo;

abstract public class JspfBase {
	protected String name;
	protected String displayName;
	protected JspfSelectionInfo selectionInfo;
	protected DatabaseInfo databaseInfo;

	abstract public void runJspf(PrintWriter out) throws SQLException, JspfMessageException;
	
	// -- getter/setter --------------------------------------------
	public JspfSelectionInfo getSelectionInfo() {
		return selectionInfo;
	}

	public void setSelectionInfo(JspfSelectionInfo selectionInfo) {
		this.selectionInfo = selectionInfo;
	}

	public DatabaseInfo getDatabaseInfo() {
		return databaseInfo;
	}

	public void setDatabaseInfo(DatabaseInfo databaseInfo) {
		this.databaseInfo = databaseInfo;
	}

	public String getDisplayName() {
		return displayName;
	}

	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void error(String message) throws JspfMessageException {
		throw new JspfMessageException(message);
	}
}
