package net.cattaka.rdbassistant.jspf.standard;

import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.List;

import net.cattaka.rdbassistant.jspf.JspfConstants;
import net.cattaka.rdbassistant.jspf.core.JspfBase;
import net.cattaka.rdbassistant.jspf.core.JspfMessageException;
import net.cattaka.rdbassistant.jspf.core.bean.ColumnInfo;
import net.cattaka.util.MessageBundle;

public class JspfBaseCreateDeleteSql extends JspfBase {

	public JspfBaseCreateDeleteSql() {
		this.setName(JspfConstants.JSPF_NAME_CREATE_DELETE_SQL);
		this.setDisplayName(MessageBundle.getMessage("create_delete_sql"));
	}
	
	@Override
	public void runJspf(PrintWriter out) throws SQLException,JspfMessageException {
		String tableName = "";
		out.println("DELETE FROM");
		if (selectionInfo.getTables().length == 1) {
			tableName = selectionInfo.getTables()[0];
			out.println("\t" + tableName);
		} else {
			error(MessageBundle.getMessage("select_single_table"));
		}
		
		// WHERE句の作成
		out.println("WHERE");
		List<ColumnInfo> cil = databaseInfo.getTableInfo(tableName).getColumnInfoList();
		boolean firstFlag = true;
		for (ColumnInfo ci : cil) {
			if (ci.isPrimaryKey()) {
				if (firstFlag) {
					firstFlag = false;
					out.print("\t");
				} else {
					out.print("\tAND ");
				}
				out.println(ci.getName() + " = ''");
			}
		}
	}
}
